<?php
/**
 * @version   $Id: profilefields.php,v bc8f018bf117 2011/02/10 11:45:57 likemandrake $
 * @author    Piotr Minkina <likemandrake@o2.pl>
 * @copyright Copyright (C) 2011 Piotr Minkina. All rights reserved.
 * @license   GNU/GPL version 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

/**
 * Displays JomSocial fields with grouping
 *
 * @author Piotr Minkina <likemandrake@o2.pl>
 */
class JElementProfileFields extends JElement
{
    /**
     * @see JElement::$_name
     */
    public $_name = 'Profile Fields';
    
    /**
     * You know... This is CONSTRUCTOR!
     *
     * Additionally adds JomSocial models to JModel include path
     *
     * @see JElement::__construct()
     */
    public function __construct($parent = null)
    {
        parent::__construct($parent);
        JModel::addIncludePath(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_community' . DS . 'models');
    }
    
    /**
     * Prepares select list of JomSocial fields
     *
     * @see JElement::fetchTooltip()
     */
    public function fetchElement($name, $value, &$node, $control_name)
    {
        $profiles = JModel::getInstance('Profiles', 'CommunityModel');
        $fields   = $profiles->getFields(false);
        $attribs  = array('class' => 'inputbox');
        $options  = array();

        if ($node->attributes('class'))
        {
            $attribs['class'] = $node->attributes('class');
        }
        $options[] = JHTML::_('select.option', '0', ' ----- ' . JText::_('Disabled') . ' ----- ');
        foreach ($fields as $field)
        {
            if (!$field->published)
            {
                continue;
            }
            if ('group' == $field->type)
            {
                $options[] = JHTML::_('select.optgroup', $field->name);
            }
            else
            {
                $options[] = JHTML::_('select.option', $field->fieldcode, $field->name);
            }
        }
        return JHTML::_('select.genericlist', $options,
                        (string) $control_name . "[$name]",
                        JArrayHelper::toString($attribs),
                        'value', 'text', $value,
                        $control_name . $name);
    }
}
